

	LIST P=18F2321, R=DEC    ; Use the PIC16F72 and decimal system 

        #include "P18F2321.INC"  ; Include header file 


	CONFIG IESO=OFF				;Internal External Switch Over mode disabled
	CONFIG FCMEN=OFF			;Fail-Safe Clock Monitor disabled
	CONFIG OSC=INTIO2			;Internal RC
	CONFIG PWRT=ON				;Enabled
	CONFIG BOR=ON				;Off
	CONFIG BORV=1				;---
	CONFIG WDT=OFF				;OFF
	CONFIG WDTPS=128			;---
	CONFIG MCLRE=ON				;ON
	CONFIG PBADEN=DIG			;PortB A/D - digital
;	CONFIG CCP2MX=OFF			;CCP2 Off
	CONFIG DEBUG=OFF			;OFF
	CONFIG LVP=OFF				;
	CONFIG STVREN=ON			;Stack overflow
	CONFIG CP0=OFF				;Block 0 Code protection ON	
	CONFIG CP1=OFF 				;Block 1 Code protection ON	
	CONFIG CPB=OFF				;Boot Block Code Protection ON
	CONFIG CPD=OFF				;Data EEPROM Code Protection OFF
	CONFIG WRT0=OFF				;Write Protection Block 0 ON
	CONFIG WRT1=OFF				;Write Protection Block 1 ON
	CONFIG WRTB=OFF				;Boot Block Write Protection ON
	CONFIG WRTC=OFF 			;Configuration Register Write Protection ON		
	CONFIG WRTD=OFF				;Data EEPROM Write Protection ON
	CONFIG EBTR0=OFF			;Table Read Protection Block 0 ON
	CONFIG EBTR1=OFF			;Table Read Protection Block 1 ON
	CONFIG EBTRB=OFF			;Boot Block Table Read Protection ON

  
;**************************************************************************
;*                     DH servis - David Hankovec	             	  *
;**************************************************************************
;*                                	PIC18F2321                        *
;*                               --------\/--------                       *
;*                         +5V  -|MCLR     PGD/RB7|-  			  *
;*              	an1  	-|RA0/AN0  PGC/RB6|-                      *
;*              	an2  	-|RA1/AN1      RB5|-    	          *
;*     			an3 	-|RA2/AN2      RB4|-  			  *
;*   	      		an4 	-|RA3/AN3  PGM/RB3|-  	  		  *
;*       		an5  	-|RA4          RB2|-       		  *
;*              	an6 	-|RA5/AN4      RB1|-        		  *
;*                  	Vss     -|Vss	   INT/RB0|-   		  	  *
;* 	    Krystal 4,00 Mhz /  -|osc1         Vdd|-    		  *
;*                           \  -|osc2         Vss|-    		  *
;*     			     	-|RC0          RC7|-  			  *
;*     				-|RC1          RC6|-  			  *
;*      	    		-|RC2          RC5|-    		  *
;*           			-|RC3/SCL  SDA/RC4|-      		  *
;*                               ------------------                       *
;*                                              DH servis (c) 2002-2009   *
;**************************************************************************


TMPW	equ	20H
FSR_TMP	equ	21H
TMPS	equ	22H
TMP0	equ	23H
TMP1	equ	24H
TMP2	equ	25H
timeout		equ	26H
count	equ	27H
tmp		equ	28H
bitcount	equ	29H
bytecount	equ	2AH
numb_reader	equ	2BH
work1		equ	2CH
;-------------------------------------
flags	equ	30H
#define Dat0			flags,0				; Wiegand D0 bit
#define Dat1			flags,1				; Wiegand D1 bit
#define dataok			flags,2
;------------------------------------
#define CARRY           STATUS,C

;------------------------------------

card1	equ	31H		;zacatek pole bytu pro kartu, 5 byte + 1 pro urceni cisla ctecky
		   ;32H
		   ;33H
		   ;34H
card2	equ	35H
		   ;36H
		   ;37H
		   ;38H
card3	equ	39H
		   ;3AH
		   ;3BH
		   ;3CH

rot		equ	3DH

#define		W_0		PORTB,0
#define		W_1		PORTB,1
#define		IN_0	PORTB,2

;---------Ctecky a vstupy-------
#define		W_3	PORTB,5
#define		W_4		PORTB,6	;ok
#define		IN_1	PORTB,3	;ok
#define		W_5		PORTB,7	;ok
#define		W_2		PORTB,4
;-------------------------------
#define		OUT_0		PORTC,0
#define		OUT_1		PORTC,1
#define		OUT_2		PORTC,2				;beeper 
#define		OUT_3		PORTC,3
#define		OUT_4		PORTC,4
#define		OUT_5		PORTC,5
;#define	TxD		PORTC,6
;#define	RxD		PORTC,7


#define		pocet_bitu	.25



	ORG 0
	goto init	
	
	ORG 8
;	goto	INT_HI

	ORG 18
	goto	INT_LO

;--------------------------------------------------------------
init
; ---------------- 
; INITIALIZE PORTS
; ---------------- 
;**************************************************************************
	bcf		OSCCON,IRCF0
	bsf		OSCCON,IRCF1
	bsf		OSCCON,IRCF2	
;-----------------------
	movlw	b'00000001'	; prednastaveni PORTu A
	movwf	PORTA
	movlw	b'11111111'	; prednastaveni PORTu B
	movwf	PORTB
	movlw	b'00000000'	; prednastaveni PORTu C
	movwf	PORTC
;------------------------
;setting digital I/O 

	bsf		ADCON1,PCFG0
	bsf		ADCON1,PCFG1
	bsf		ADCON1,PCFG2
	bsf		ADCON1,PCFG3
	bsf		CMCON,CM0
	bsf		CMCON,CM1
	bsf		CMCON,CM2	;konfigurace vstupu nastavena

;------------------NASTAVENI PORTU A--------------------------------------------
    movlw b'0000001'		;
    movwf TRISA		; portA	

;-------------------------------------------------------------------------------

;------------------NASTAVENI PORTU B--------------------------------------------
	bcf	INTCON2,RBPU	; PULL-UPy ON

	movlw	b'11111111'	; portB 
	movwf	TRISB

;------------------NASTAVENI PORTU C--------------------------------------------
	movlw	b'10000000'	;
	movwf	TRISC
;-------------------------------------------------------------------------------

;-------------------------------------------------------------------
;setting tmr0
;
	bcf	T0CON,T0CS			;interni casovac
	bcf	T0CON,T08BIT		;16 bits
	bsf	T0CON,PSA			;preddelicka OFF
	
	clrf	TMR0H
	clrf	TMR0L


	bcf	T0CON,TMR0ON
	bcf	INTCON,TMR0IF
	bsf	INTCON,TMR0IE		;interrupt setting

;------------------------------------------------------------------------------
	bsf	PIE1,RCIE
	bcf	PIR1,RCIF

	bcf	INTCON,RBIF
	bsf	INTCON,RBIE

	bcf	INTCON,INT0IF
	bcf	INTCON2,INTEDG0
	bsf	INTCON,INT0IE


	bcf	INTCON2,INTEDG1
	bcf	INTCON3,INT1IF
	bsf	INTCON3,INT1IE



	bsf	INTCON,PEIE
	bsf	INTCON,GIE

;-----------------HLAVNI SMYCKA---------------------------
;cold start !!

	clrf	flags
	clrf	numb_reader
	
	clrf	flags
 	call	SET_232

	movf	PORTB,W
	movlw	pocet_bitu
	movwf	count
	bcf		dataok
	call	vymazat_data


main:

	goto	main	


;MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
;MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
;MMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMMM
INT_LO
;interrupt po 5 msec od TMR1
	movwf	TMPW		; ulozi W
	swapf	STATUS,W	; prohodi nibble STATUS a ulozi do W
	movwf	TMPS		; ulozit STATUS
	movf	FSR0,W
	movwf	FSR_TMP
;---------------------------------------	
	btfsc	PIR1,RCIF
	goto	int_uart
;preruseni od wieganda na RB0,1
	btfsc	INTCON,INT0IF
	goto	wie0_int0			;int od voice H nebo L snimace 0
	btfsc	INTCON3,INT1IF
	goto	wie0_int1
;---------------------------------------
;snimac 1 a 2 jsou na preruseni na zmenu urovne
	btfsc	INTCON,RBIF	
	goto	readers
	btfsc	INTCON,TMR0IF
	goto	T0_Int


	goto	IntRet					;zatim bez obsluhy
;----------------------------------------------------------------
;preruseni od snimace 0 na PORTB0 nebo PORTB1
wie0_int0
	bcf		INTCON,INT0IF
	btfsc	W_0
	goto	IntRet							;chyba na druhem vstupu
	clrf	WREG
	cpfseq	numb_reader
	goto	por0_0
	movlw	.1								;otestuj, zda uz se necte jina ctecka
	movwf	numb_reader	
	goto	loop0_0
por0_0
	movlw	.1
	cpfseq	numb_reader
	goto	IntRet
loop0_0
	movlw	card1+3							;setting indirect addresing
	movwf	FSR0L
	clrf	FSR0H
	goto	data0
;--------------------------
wie0_int1
	bcf		INTCON3,INT1IF	
	btfsc	W_1
	goto	IntRet							;chyba na druhem vstupu
	clrf	WREG
	cpfseq	numb_reader
	goto	por_0
	movlw	.1								;otestuj, zda uz se necte jina ctecka
	movwf	numb_reader	
	goto	loop_0
por_0
	movlw	.1
	cpfseq	numb_reader
	goto	IntRet
loop_0
	movlw	card1+3							;setting indirect addresing
	movwf	FSR0L
	clrf	FSR0H
	goto	data1
;----------------------------------------------------------------
readers
	movf	PORTB,W
	bcf		INTCON,RBIF
	andlw	b'11110000'
	movwf	work1							;ulozen stav portu
;- and now.....its a work for a Gods :)

	movlw	b'11010000'						;maska snimac 2 vodic H

	cpfseq	work1
	goto	test1
;ctecka cislo 2 vodic H
	clrf	WREG
	cpfseq	numb_reader
	goto	por4
	movlw	.2								;otestuj, zda uz se necte jina ctecka
	movwf	numb_reader	
	goto	loop4
por4
	movlw	.2
	cpfseq	numb_reader
	goto	IntRet
loop4
	movlw	card2+3							;setting indirect addresing
	movwf	FSR0L
	clrf	FSR0H
	goto	data1
;-----------------------------------------------------------------
test1
;pro debug
	movlw	b'11100000'						;maska snimac 2 vodic L

	cpfseq	work1
	goto	test2
;ctecka cislo 2 vodic L
	clrf	WREG
	cpfseq	numb_reader
	goto	por3
	movlw	.2								;otestuj, zda uz se necte jina ctecka
	movwf	numb_reader	
	goto	loop3
por3
	movlw	.2
	cpfseq	numb_reader
	goto	IntRet
loop3
	movlw	card2+3							;setting indirect addresing
	movwf	FSR0L
	clrf	FSR0H
	goto	data0
;-----------------------------------------------------------------
test2
	movlw	b'01110000'						;maska snimac 3 vodic H
	cpfseq	work1
	goto	test3
;ctecka cislo 3 vodic H
	clrf	WREG
	cpfseq	numb_reader
	goto	por2
	movlw	.3								;otestuj, zda uz se necte jina ctecka
	movwf	numb_reader	
	goto	loop2
por2
	movlw	.3
	cpfseq	numb_reader
	goto	IntRet
loop2
	movlw	card3+3							;setting indirect addresing
	movwf	FSR0L
	clrf	FSR0H
	goto	data1
;-----------------------------------------------------------------
test3
;pro debug
	movlw	b'10110000'						;maska snimac 3 vodic L
	cpfseq	work1
	goto	IntRet
;ctecka cislo 3 vodic L
	clrf	WREG
	cpfseq	numb_reader
	goto	por1
	movlw	.3								;otestuj, zda uz se necte jina ctecka
	movwf	numb_reader	
	goto	loop1
por1
	movlw	.3
	cpfseq	numb_reader
	goto	IntRet
loop1
	movlw	card3+3							;setting indirect addresing
	movwf	FSR0L
	clrf	FSR0H
	goto	data0
;-----------------------------------------------------------------


; **** datovy bit 1 aktivni (v nule) ****
data1:								
				bsf	CARRY					
				goto	data0b					
; **** data bit 0 aktivni v nule  ****
data0:									
				bcf	CARRY				
; **** narotovn bit ****
data0b:	
				bsf	T0CON,TMR0ON
				rlcf	INDF0,F				
				decfsz	FSR0L,F
				rlcf	INDF0,F				
				decfsz	FSR0L,F
				rlcf	INDF0,F				
				decfsz	FSR0L,F
				rlcf	INDF0,F	

				decfsz	count,F
				goto	data_out					; nen konec

				movlw	pocet_bitu				; je konec
				movwf	count
				bsf	dataok
				clrf	TMR0H
				clrf	TMR0L
				bcf	T0CON,TMR0ON
				
				movlw	card1
				movwf	FSR0L
				clrf	FSR0H
posli_cards
				movf	INDF0,W
				call	send
				incf	FSR0L,F
				movlw	card3+3
				xorwf	FSR0L,W
				btfss	STATUS,Z
				goto	posli_cards
				call	vymazat_data
				clrf	numb_reader
data_out	
				goto	IntRet
		
T0_Int                                            
				bcf	T0CON,TMR0ON					
				bcf	INTCON,TMR0IF
				bcf	dataok					;clr data ok flag
		 		movlw	pocet_bitu				; je konec
				movwf	count
				call	vymazat_data
				clrf	numb_reader
				clrf	TMR0H
				clrf	TMR0L
				goto	IntRet 
; *************************************************************************************************************

int_uart
	btfss	RCSTA,OERR
	bra		uart1
	bcf		RCSTA,CREN
	bsf 	RCSTA,CREN
uart1
	movf	RCREG,W
	movwf	tmp		
	goto	IntRet	

;------------------------------------------------------------
IntRet 
	bcf		INTCON,RBIF
	clrwdt
	movf	FSR_TMP,W
	movwf	FSR0
	swapf TMPS,W ; pvodn registr STATUS do W 
  	movwf STATUS ; navrcen registru STATUS 
  	swapf TMPW,F ; prprava pvodnho registru W 
  	swapf TMPW,W ; nvrat pvodnho registru W 
   	retfie 
;------------------------------------------------------------
vymazat_data
	movlw	card3+3
	movwf	FSR0L
	clrf	FSR0H
smaz_cards
	clrf	INDF0
	decf	FSR0L,F
	movlw	card1-1
	xorwf	FSR0L,W
	btfss	STATUS,Z
	goto	smaz_cards


cek_10msc
;Variables: TMP1, TMP0
;Delay 9998 cycles
        MOVLW 0x0D  ;13 DEC
        MOVWF TMP1
_minus5
        MOVLW 0x0FF  ;255 DEC
        MOVWF TMP0
_minus1
        DECFSZ TMP0,F
        GOTO _minus1
        DECFSZ TMP1,F
        GOTO _minus5
;End of Delay
		return

;--------------------------------------------------------------------

; -------------------------------------------------------------
; SEND CHARACTER IN W VIA RS232 AND WAIT UNTIL FINISHED SENDING 
; -------------------------------------------------------------
;
send    clrwdt
		movwf TXREG             ; send data in W 

TransWt 
WtHere  btfss TXSTA,TRMT        ; (1) transmission is complete if hi
        goto WtHere
        return

;----------------------------------------------------------------


; -------------------------------------------
; RECEIVE CHARACTER FROM RS232 AND STORE IN W
; -------------------------------------------
; This routine does not return until a character is received.
;
receive 
	BTFSS	RCSTA,OERR
	GOTO	rec1
	BCF RCSTA,CREN
	BSF RCSTA,CREN
rec1
	BTFSS PIR1,RCIF
	GOTO rec1
	MOVF RCREG,W
	RETURN
;**************************************************************************
SET_232	
	bsf	PIE1,RCIE		;povol INT od seriove linky	
	movlw	.12			;12
	movwf	SPBRG
;------------------------
	movlw	b'00100110'	; 8bit, vysln povoleno, asynchron mod, vysok rychlost
	movwf	TXSTA		; !!! nastaven vysln !!!
;-------------------------------
	movlw	b'10010000'	; povolen sriov port, 8bit, asynchron mod
	movwf	RCSTA		; !!! nastaven pjmu !!!
	return

;**************************************************************************


	END


